
<template>
  <div class="mt-5">
    <div class="row justify-content-center ">
      <div class="col-md-8 col-lg-5">
        <div class="card">
          <div class="card-header">Login</div>

          <div class="card-body">
            <form>
              <div class="form-group row">
                <label for="username" class="col-sm-4 col-form-label text-md-right">Email</label>

                <div class="col-md-6">
                  <input
                    type="text"
                    name="Email"
                    class="input-border-less form-control"
                    v-model="email"
                    required
                    autofocus
                  >
                </div>
              </div>

              <div class="form-group row">
                <label for="password" class="col-md-4 col-form-label text-md-right">Password</label>

                <div class="col-md-6">
                  <input
                    id="password"
                    type="password"
                    class="input-border-less form-control"
                    name="password"
                    required
                    v-model="password"
                  >
                </div>
              </div>
              <div class="form-group row">
                <div class="col-md-6 offset-md-4"></div>
              </div>
              <div class="form-group row mb-0">
                <div class="col-md-8 offset-md-4">
                  <button type="submit" class="btn btn-primary" @click="handleSubmit">Login</button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import toastr from "toastr";
import EventBus from "@/main";
import socket from "@/main";
export default {
  data() {
    return {
      email: "",
      password: "",
      isConnected: false
    };
  },
  mounted: function() {},
  methods: {
    handleSubmit(e) {
      e.preventDefault();
      if (this.password.length > 0 && this.email.length > 0) {
        //console.log("asking for auth");
        this.$socket.emit("login", {
          body: {
            email: this.email.trim().toLowerCase(),
            password: this.password.trim()
          }
        });
        this.$socket.on("authRes", response => {
          //console.log("auth ok ");
          if (response.body.auth) {
            let is_admin = response.body.user.is_admin;
            localStorage.setItem("user", JSON.stringify(response.body.user));
            localStorage.setItem("jwt", response.body.token);
            EventBus.$emit("updateUser",response.body.user);
            if (localStorage.getItem("jwt") != null) {
              this.$emit("loggedIn");
              if (this.$route.params.nextUrl != null) {
                this.$router.push(this.$route.params.nextUrl);
              } else {
                if (is_admin == 1) {
                  this.$router.push("admin");
                } else {
                  this.$router.push("dashboard/" + response.body.user.name);
                }
              }
            }
          } else {
            //console.log("auth ko");
            this.$toastr.error(
              "Mail or Password incorrect",
              "Autentication Failed",
              { preventDuplicates: true, progressBar: true }
            );
          }
        });
      } else {
        var err = " ";
        if (this.email.length == 0) err = " Email field is requierd.<br> ";
        if (this.password.length == 0)
          err = err + " Password field is requierd. ";
        this.$toastr.error(err, "Autentication Failed", {
          preventDuplicates: true,
          progressBar: true
        });
      }
    }
  }
};
</script>
<style>
</style>
